#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <pthread.h>
#include <stdlib.h>

#include <iostream>
using namespace std;

void *watchingThread(void *);
char *timeFormat( time_t now );

int main( int argc, char *argv[] )
{
	pthread_t tid;

	if( argc != 2 )
	{
		cout << "usage : mtime [filename]" << endl;
		return 0;
	}

	if( access( argv[1], R_OK|F_OK ) )
	{
		cout << "Can not access file : " << argv[1] << endl;
		return 0;
	}

	pthread_create( &tid, NULL, watchingThread, argv[1] );
	
	while( getchar() != 'q' );

	return 0;
}

void *watchingThread(void *pt)
{
	char  *path  = (char*)pt;
	time_t mtime = 0;

	struct stat st;
	
	while( true )
	{
		stat( path, &st );
		if( st.st_mtime != mtime )
		{
			mtime = st.st_mtime;
			printf("Modified Time Changed : [%s] %s\n", path, timeFormat(mtime));
		}
		usleep(100);
	}

	return 0;
}

char *timeFormat( time_t now )
{
	struct tm *timeTmp = localtime( &now );
	static char buf[128];
	bzero( buf, sizeof(buf) );

	sprintf( buf,
			 "%02d%02d%02d-%02d:%02d:%02d",
			 timeTmp->tm_year-100,
			 timeTmp->tm_mon+1,
			 timeTmp->tm_mday,
			 timeTmp->tm_hour,
			 timeTmp->tm_min,
			 timeTmp->tm_sec );

	return buf;
}
