/*===================================//
 *
 * fm.h
 *
 * fm.cpp
 *
 * written by JS. Park.
 *
 * modified by JH. Cho.
 *
 *===================================*/
#ifndef __FM_H__
#define __FM_H__
#include "acha.h"

class FileManager : public ACHABase
{
	// 상태변수들
	public :
		bool lockState;
		vector<scanInfo> 	lastList;
		vector<scanInfo>	scanList;
		scanInfo element;

	private :
		bool m_bIsRun;

			//DIR *dpScan;
		struct stat fs;
		struct dirent *dp;
		

		int  scanSubDirectory(char *, time_t*);
		void loadChangedFile(char *);
		void writeChangedFile( char * );
		void showList(int);
	public :
		void writeCFL(char * );

	public :		
		pthread_t	m_tid;			// FileTransfer의 threadID
		ACHA		*acha;

		vector<changeInfo>	changeList;

		FileManager(ACHA *);		
		~FileManager();

		void dispSettings(void);
		int  isChanged(syncListNode *);		// SM에서 호출

		int init(void);
		int run(void);
		int cleanup(void);
};
#endif
