/*===================================//
 *
 * sm.h
 *
 * sm.cpp
 *
 * written by JH. Cho.
 *
 *===================================*/
#ifndef __SYNCMANAGER_H__
#define __SYNCMANAGER_H__

#include "acha.h"

class SyncManager : public ACHABase
{
	private :
		char 				m_sCurSyncName[SDATA];	// 현재 동기화 작업중이 SyncName
	public :
		syncListNode 		slnTmp;					// SyncListNode Tmp
		ACHA				*acha;					// ACHA Pointer
		pthread_t			m_tid;					// SyncProc의 threadID
		FILE 				*fpSyncList;			// SyncList File Pointer
		deque<syncListNode> syncList;

	public :
		SyncManager(ACHA *pAcha);
		~SyncManager();

		void test(void);						// Test 용

		void loadSyncList(ACHA *);				// SyncList(File)를 로드하는 함수 
		void cleanSyncList(ACHA *); 			// syncList를 초기화 하는 함수
		void cleanSyncListNode(syncListNode ); 	// syncListNode한개의 메모리 해제
		void writeSyncList( void ); 			// syncList(Memory)를 파일로 쓰는 함수

		int syncExist( char *name ); 			// 해당 이름이 존재하는지 확인

		void setFlag(char *, int);				// 해당 flag를 on/off하는 함수
		bool isFlag(char *, int);				// 해당 flag가 set 되어 있는지 확인하는 함수	

		void updateFileSize(char *, int);
		void updateOption(char *, int);

		// 새로운 sync를 생성하는 함수
		int addSync( char*, char*, char*, char*, int, char *, char *, int);

		int delSync( char * );
		int delSyncNode( char * );

		char *getTargetbyName( char * );
		int  updateSyncTime( char * , time_t );
		void updateFlag( char *, int );

		void clean_slnTmp( void );

		static void *syncProc( void * );
		int syncProcess( void *, int );

		void dispSettings( void );
		void showList( void );

		void SetCurSyncName( char *sName );		// 현재 동기화 중인 SyncName을 저장한다.
		char *GetCurSyncName() { return m_sCurSyncName; }

		///////////////////////////////////////////
		int init(void);			// 초기화
		int run(void);			// 메인 함수
		int cleanup(void);		// 종료루틴
};

#endif
